// Code generated by mockery v2.53.0. DO NOT EDIT.

package db

import (
	context "context"

	mock "github.com/stretchr/testify/mock"
	models "gitlab.com/infor-cloud/martian-cloud/phobos/phobos-api/internal/models"
)

// MockServiceAccounts is an autogenerated mock type for the ServiceAccounts type
type MockServiceAccounts struct {
	mock.Mock
}

// AssignServiceAccountToAgent provides a mock function with given fields: ctx, serviceAccountID, agentID
func (_m *MockServiceAccounts) AssignServiceAccountToAgent(ctx context.Context, serviceAccountID string, agentID string) error {
	ret := _m.Called(ctx, serviceAccountID, agentID)

	if len(ret) == 0 {
		panic("no return value specified for AssignServiceAccountToAgent")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, string, string) error); ok {
		r0 = rf(ctx, serviceAccountID, agentID)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// CreateServiceAccount provides a mock function with given fields: ctx, serviceAccount
func (_m *MockServiceAccounts) CreateServiceAccount(ctx context.Context, serviceAccount *models.ServiceAccount) (*models.ServiceAccount, error) {
	ret := _m.Called(ctx, serviceAccount)

	if len(ret) == 0 {
		panic("no return value specified for CreateServiceAccount")
	}

	var r0 *models.ServiceAccount
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.ServiceAccount) (*models.ServiceAccount, error)); ok {
		return rf(ctx, serviceAccount)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *models.ServiceAccount) *models.ServiceAccount); ok {
		r0 = rf(ctx, serviceAccount)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.ServiceAccount)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *models.ServiceAccount) error); ok {
		r1 = rf(ctx, serviceAccount)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeleteServiceAccount provides a mock function with given fields: ctx, serviceAccount
func (_m *MockServiceAccounts) DeleteServiceAccount(ctx context.Context, serviceAccount *models.ServiceAccount) error {
	ret := _m.Called(ctx, serviceAccount)

	if len(ret) == 0 {
		panic("no return value specified for DeleteServiceAccount")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.ServiceAccount) error); ok {
		r0 = rf(ctx, serviceAccount)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetServiceAccountByID provides a mock function with given fields: ctx, id
func (_m *MockServiceAccounts) GetServiceAccountByID(ctx context.Context, id string) (*models.ServiceAccount, error) {
	ret := _m.Called(ctx, id)

	if len(ret) == 0 {
		panic("no return value specified for GetServiceAccountByID")
	}

	var r0 *models.ServiceAccount
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.ServiceAccount, error)); ok {
		return rf(ctx, id)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.ServiceAccount); ok {
		r0 = rf(ctx, id)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.ServiceAccount)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, id)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetServiceAccountByPRN provides a mock function with given fields: ctx, prn
func (_m *MockServiceAccounts) GetServiceAccountByPRN(ctx context.Context, prn string) (*models.ServiceAccount, error) {
	ret := _m.Called(ctx, prn)

	if len(ret) == 0 {
		panic("no return value specified for GetServiceAccountByPRN")
	}

	var r0 *models.ServiceAccount
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.ServiceAccount, error)); ok {
		return rf(ctx, prn)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.ServiceAccount); ok {
		r0 = rf(ctx, prn)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.ServiceAccount)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, prn)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetServiceAccounts provides a mock function with given fields: ctx, input
func (_m *MockServiceAccounts) GetServiceAccounts(ctx context.Context, input *GetServiceAccountsInput) (*ServiceAccountsResult, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for GetServiceAccounts")
	}

	var r0 *ServiceAccountsResult
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *GetServiceAccountsInput) (*ServiceAccountsResult, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *GetServiceAccountsInput) *ServiceAccountsResult); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*ServiceAccountsResult)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *GetServiceAccountsInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UnassignServiceAccountFromAgent provides a mock function with given fields: ctx, serviceAccountID, agentID
func (_m *MockServiceAccounts) UnassignServiceAccountFromAgent(ctx context.Context, serviceAccountID string, agentID string) error {
	ret := _m.Called(ctx, serviceAccountID, agentID)

	if len(ret) == 0 {
		panic("no return value specified for UnassignServiceAccountFromAgent")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, string, string) error); ok {
		r0 = rf(ctx, serviceAccountID, agentID)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// UpdateServiceAccount provides a mock function with given fields: ctx, serviceAccount
func (_m *MockServiceAccounts) UpdateServiceAccount(ctx context.Context, serviceAccount *models.ServiceAccount) (*models.ServiceAccount, error) {
	ret := _m.Called(ctx, serviceAccount)

	if len(ret) == 0 {
		panic("no return value specified for UpdateServiceAccount")
	}

	var r0 *models.ServiceAccount
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.ServiceAccount) (*models.ServiceAccount, error)); ok {
		return rf(ctx, serviceAccount)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *models.ServiceAccount) *models.ServiceAccount); ok {
		r0 = rf(ctx, serviceAccount)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.ServiceAccount)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *models.ServiceAccount) error); ok {
		r1 = rf(ctx, serviceAccount)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// NewMockServiceAccounts creates a new instance of MockServiceAccounts. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockServiceAccounts(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockServiceAccounts {
	mock := &MockServiceAccounts{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
